; Lab5 part D
; Andrew Fowler
; Damian Szmulewicz Section: 3276
; Playing Sounds and other stuff with the ePWM system and CPU timers.

GPAMUX1 	.set 	0x6F86
GPAMUX2 	.set 	0x6F87
WDCR		.set	0x7029
GPADIR 		.set	0x6F8A
GPADAT 		.set 	0x6FC0
GPATOGGLE	.set	0x6FC6
PIEIFR3		.set	0x0CE6
TBCTR 		.set	0x6804
PCLKCR0		.set	0x701C
PCLKCR1		.set	0x701D
TBPRD		.set	0x6805
CMPB		.set	0x694A
CMPA		.set	0x6949
TBCTL		.set	0x6800
AQCTLA		.set	0x680B
CMPCTL		.set	0x6947	


			.global _c_int00	;This assembler directive allows _c_int00 to be a
								;global variable.
;****************************************************************************************
.text	;program section, see the command linker file, program code
		;should be placed in the text section which starts at 0x9000

_c_int00:
	LC INIT_CPU			;initialize CPU (objmode, disable watchdog)
	LC INIT_OUTPUTS		; GPIO epwm/LEDs for debugging
	LC INIT_EPWM_REST	; Initializes the sound timer
		
WAIT	B WAIT, UNC		; Endless loop waiting for interupts.
	
	
	
INIT_CPU:
		EALLOW 						; Allow access to protected registers
		SETC 	OBJMODE 			; Allow 32 bit mov instructions
		SETC 	VMAP			; 
								; WDCR is watchdog timer control register
								; In constants section need to set WDCR=0x7029
		MOV 	AL,#1101000b 	; Disable the watchdog timer.
								; Must have 101 in bits 5, 4, 3 for
								; any writes to WDCR. 1 in bit 6
								; disables watchdog
		MOV 	AR1,#WDCR
		MOV		*AR1, AL 		; Disables watchdog timer

INIT_OUTPUTS:
	PUSH AR0
	PUSH AR1
	MOV AR0,#0x1		;set Mux for EPWM1A and the rest i/o
	MOV AR1,#GPAMUX1	
	MOV *AR1,AR0
	POP AR1
	POP AR0
	LRET

INIT_EPWM_REST:
	INC AR5
	MOV AR0, #PCLKCR1	; enables the epwm1 timers
	OR *AR0, #0x1

	MOV	AR0, #TBCTL	; sets all the needed ctrl registers for the epwm
	MOV	AR1, #0xC0B8	
	MOV	*AR0, AR1
	
	MOV AR0, #TBPRD		; sets the toggler frequency so you can play music
	MOV	AR1, #533
	MOV	*AR0, AR1

	MOV AR0, #AQCTLA	; makes it so it toggles and when the counter gets to the period
	MOV	AR1, #0xC
	MOV	*AR0, AR1
	
	MOV AR0, #PCLKCR0	; Enables the TimerCLK for the epwm (also needs PCLKCCR1)
	OR *AR0, #0x4
	
;	MOV AR0, #CMPCTL	; Could never get the interupts working, but decided
;	MOV	AR1, #0x50		; it was not that important anyway so these are not needed
;	MOV	*AR0, AR1
	
;	MOV	AR0, #CMPB		; also for doing interupts
;	MOV	AR1, #0xF0F0
;	MOV	*AR0, AR1
	
	LRET