; Lab7 part 2 - PLAYING MUSIC!!!
; Andrew Fowler
; Damian Szmulewicz Section: 3276
; Keypad polling and then music playing
;
; So this program polls the keypad and then plays the frequency
; according to the table below. The timer from part A will be used 
; for playing the square wave note, and the internal CPU timer
; will be use for the .5 second or .25 second timers.
;
;********************************************************
;	Thanks to excel here is the conversion table		*
;														*
;	Keypad	Note	Frequency	Cycles					*
;	1		B5		987.77		949						*
;	2		C6		1046.5		896						*
;	3		C6#		1108.73		846						*
;	4		D6		1174.66		798						*
;	5		D6#		1244.51		753						*
;	6		E6		1318.51		711						*
;	7		F6		1396.91		671						*
;	8		F6#		1479.98		633						*
;	9		G6		1567.98		599						*
;	0		G6#		1661.22		564						*
;	A		A6		1760		533						*
;	B		A6#		1864.66		503						*
;	C		B6		1975.53		475						*
;	D		C7		2093		448						*
;														*
;********************************************************

		.global		_c_int00

data_sect	.set		0xa000			;constant that is actually the starting addr of .data section
bss_sect	.set		0xb000			;constant that is actually the starting addr of .bss section
GPAMUX1 	.set 	0x6F86
GPAMUX2 	.set 	0x6F87
WDCR		.set	0x7029
GPADIR 		.set	0x6F8A
GPADAT 		.set 	0x6FC0
GPATOGGLE	.set	0x6FC6
PIEIFR3		.set	0x0CE6
TBCTR 		.set	0x6804
PCLKCR0		.set	0x701C
PCLKCR1		.set	0x701D
TBPRD		.set	0x6805
CMPB		.set	0x694A
CMPA		.set	0x6949
TBCTL		.set	0x6800
AQCTLA		.set	0x680B
CMPCTL		.set	0x6947	
TIMER1PRD	.set 	0x0C0A		
TIMER1TCR	.set	0x0C0C		
TIMER1PR	.set	0x0C0E		
TIMER1PR	.set	0x0C0E		;msb current prescaler count, prescale amount [low bytes]
TIMER1PRH	.set 	0x0C0F		;msb current prescaler count, prescale amount [high bytes]
PERIODL		.set	6553		
PERIODH		.set 	0
TIMER1PRDH	.set 	0x0C0B		;holds period of counter [high]
PRESCALEL	.set	0x0			;8-bit lower prescale value
PRESCALEH	.set	0x00		;8-bit upper prescale value
INT13_VECT	.set	0x00001A
TIMREGPG	.set	0xC00>>6
;*****************************************************************

		.data				

Key1    .byte    	"B5 - 987.77 HZ " 	;define string, ASCII characters placed in memory as WORDS!
		.byte		0
Key2    .byte    	"C6 - 1046.50 HZ " 	;define string, ASCII characters placed in memory as WORDS!
		.byte		0
Key3    .byte    	"C#6/Db6 - 987.77 HZ " 	;define string, ASCII characters placed in memory as WORDS!
		.byte		0
Key4    .byte    	"D6 - 1174.66 HZ " 	;define string, ASCII characters placed in memory as WORDS!
		.byte		0
Key5    .byte    	"D#6/Eb6 - 1244.51 HZ " 	;define string, ASCII characters placed in memory as WORDS!
		.byte		0
Key6    .byte    	"E6 - 1318.51 HZ " 	;define string, ASCII characters placed in memory as WORDS!
		.byte		0		
Key7    .byte    	"F6 - 1396.91 HZ " 	;define string, ASCII characters placed in memory as WORDS!
		.byte		0		
Key8    .byte    	"F#6/Gb6 - 1479.98 HZ " 	;define string, ASCII characters placed in memory as WORDS!
		.byte		0		
Key9    .byte    	"G6 - 1567.98 HZ " 	;define string, ASCII characters placed in memory as WORDS!
		.byte		0	
Key0    .byte    	"G#6/Ab6 - 1661.22 HZ " 	;define string, ASCII characters placed in memory as WORDS!
		.byte		0
KeyA    .byte    	"A6 - 1760.00 HZ " 	;define string, ASCII characters placed in memory as WORDS!
		.byte		0				
KeyB    .byte    	"A#6/Bb6 - 1864.66HZ " 	;define string, ASCII characters placed in memory as WORDS!
		.byte		0			
KeyC    .byte    	"B6 - 1975.53 HZ " 	;define string, ASCII characters placed in memory as WORDS!
		.byte		0			
KeyD    .byte    	"C7 - 2093.00 HZ " 	;define string, ASCII characters placed in memory as WORDS!
		.byte		0	
Key15    .byte    	"Ascending Scale " 	;define string, ASCII characters placed in memory as WORDS!
		.byte		0	
Key14    .byte    	"Decending Scale " 	;define string, ASCII characters placed in memory as WORDS!
		.byte		0			
		
Start	.word		949
		.word		896
		.word		846
		.word		798
		.word		753
		.word		711
		.word		671
		.word		633
		.word		599
		.word		564
		.word		533
		.word		503
		.word		475
		.word		448
		.byte		0

		.global		Start		;.global directive lets you to see the assigned addresses in map file.	
		
;****************** Part A ***********************
		.text					; Program section, see the command linker file, program code 
								; should be placed in the text section which starts at 0x9000
						
_c_int00:						; This label tells the linker where the entry (starting) point for 
	LC CPU_INIT
	LC INIT_OUTPUTS
	OR IER,#0x2000		;enable Timer interupts
	CLRC INTM			;enable global interrupts (by clearing the global interrupt mask)
;***********************************************
; 			KEYPAD POLLING					   *
;***********************************************

Keypad	LC		DELAY2
		MOV		AL, #0x0001		;Sets all pins to input/output so we can use them
		MOV		AR1, #GPAMUX1
		MOV		*AR1,AL
		MOV		AL, #0x0F0F		;Sets GPIO to input and output (1=out) so we want 0000|1111|0000|1111
		MOV		AR1, #GPADIR
		MOV		*AR1,AL
		
		; Write the correct things to pins 5-8
		; Read input at 1
		; Check input to see if its 1 or 0
		;		If 1 display LED and DELAY
		;		If Zero, skip and keep going
		
		MOV		AR1, #GPADAT	; Makes AR1 the location of GPADAT
		MOV		AL, *AR1		; MOves the data at GPADAT to AH so we can do operations with it
		AND		AL, #0xF		; Preserves LED configuration that is being displayed right now also clears the other pins
								;   that the next step will use
		MOV		AH, #0x700		; Set 2/3/4 to 1, 1 to 0 =  0111|0000|0000
		OR		AL, AH			;
		MOV		*AR1, AL		;
		LC		DELAY2
;Read inputc
		MOV		AR1, #GPADAT	; Sets AR0 to the read the input register
		MOV		AL, *AR1		; Moves contents of GPADAT to accumulator
		AND		AL, #0x1000		; Checks to see if bit 1 is zero or 1
		nop
		nop
		nop
		 B		skipB,NEQ		; If the pin is not 0 it means no key is presed so we need to skip LED setting
;Set LED part
		LC		KeyAc
		B		Keypad, UNC
; So the progress here is, the first key is done, now the code just has to be copy pasted and changed a little bit so
; it can be resued for all the possible pins
skipB	
		MOV		AR1, #GPADAT	; Makes AR1 the location of GPADAT
		MOV		AL, *AR1		; MOves the data at GPADAT to AH so we can do operations with it
		AND		AL, #0xF		; Preserves LED configuration that is being displayed right now also clears the other pins
								;   that the next step will use
		MOV		AH, #0x700		; Set 2/3/4 to 1, 1 to 0 =  0111|0000|0000
		OR		AL, AH			;
		MOV		*AR1, AL		;
;Read input
		MOV		AR1, #GPADAT	; Sets AR0 to the read the input register
		MOV		AL, *AR1		; Moves contents of GPADAT to accumulator
		AND		AL, #0x2000		; Checks to see if bit 1 is zero or 1
		 B		skipC,NEQ		; If the pin is not 0 it means no key is presed so we need to skip LED setting
;Set LED part
		LC		KeyBc
		B		Keypad, UNC
skipC
		MOV		AR1, #GPADAT	; Makes AR1 the location of GPADAT
		MOV		AL, *AR1		; MOves the data at GPADAT to AH so we can do operations with it
		AND		AL, #0xF		; Preserves LED configuration that is being displayed right now also clears the other pins
								;   that the next step will use
		MOV		AH, #0x700		; Set 2/3/4 to 1, 1 to 0 =  0111|0000|0000
		OR		AL, AH			;
		MOV		*AR1, AL		;
;Read input
		MOV		AR1, #GPADAT	; Sets AR0 to the read the input register
		MOV		AL, *AR1		; Moves contents of GPADAT to accumulator
		AND		AL, #0x4000		; Checks to see if bit 1 is zero or 1
		 B		skipD,NEQ		; If the pin is not 0 it means no key is presed so we need to skip LED setting
;Set LED part
		LC		KeyCc
		B		Keypad, UNC
skipD
		MOV		AR1, #GPADAT	; Makes AR1 the location of GPADAT
		MOV		AL, *AR1		; MOves the data at GPADAT to AH so we can do operations with it
		AND		AL, #0xF		; Preserves LED configuration that is being displayed right now also clears the other pins
								;   that the next step will use
		MOV		AH, #0x700		; Set 2/3/4 to 1, 1 to 0 =  0111|0000|0000
		OR		AL, AH			;
		MOV		*AR1, AL		;
;Read input
		MOV		AR1, #GPADAT	; Sets AR0 to the read the input register
		MOV		AL, *AR1		; Moves contents of GPADAT to accumulator
		AND		AL, #0x8000		; Checks to see if bit 1 is zero or 1
		 B		skip3,NEQ		; If the pin is not 0 it means no key is presed so we need to skip LED setting
;Set LED part
		LC		KeyDc
		B		Keypad, UNC
		
;*******************************************************************************************************


; NEXT COLUMN --- 3-#



;********************************************************************************************************
		
		
		
		
		
skip3:	MOV		AR1, #GPADAT	; Makes AR1 the location of GPADAT
		MOV		AL, *AR1		; MOves the data at GPADAT to AH so we can do operations with it
		AND		AL, #0xF		; Preserves LED configuration that is being displayed right now also clears the other pins
								;   that the next step will use
		MOV		AH, #0xB00		; Set 2/3/4 to 1, 1 to 0 =  1011|0000|0000
		OR		AL, AH			;
		MOV		*AR1, AL		;
		LC		DELAY2
;Read input
		MOV		AR1, #GPADAT	; Sets AR0 to the read the input register
		MOV		AL, *AR1		; Moves contents of GPADAT to accumulator
		AND		AL, #0x1000		; Checks to see if bit 1 is zero or 1
		 B		skip6,NEQ		; If the pin is not 0 it means no key is presed so we need to skip LED setting
;Set LED part
		LC		Key3c
		B		Keypad, UNC

skip6	
		MOV		AR1, #GPADAT	; Makes AR1 the location of GPADAT
		MOV		AL, *AR1		; MOves the data at GPADAT to AH so we can do operations with it
		AND		AL, #0xF		; Preserves LED configuration that is being displayed right now also clears the other pins
								;   that the next step will use
		MOV		AH, #0xB00		; Set 2/3/4 to 1, 1 to 0 =  1011|0000|0000
		OR		AL, AH			;
		MOV		*AR1, AL		;
;Read input
		MOV		AR1, #GPADAT	; Sets AR0 to the read the input register
		MOV		AL, *AR1		; Moves contents of GPADAT to accumulator
		AND		AL, #0x2000		; Checks to see if bit 1 is zero or 1
		 B		skip9,NEQ		; If the pin is not 0 it means no key is presed so we need to skip LED setting
;Set LED part
		LC		Key6c
		B		Keypad, UNC
		
skip9
		MOV		AR1, #GPADAT	; Makes AR1 the location of GPADAT
		MOV		AL, *AR1		; MOves the data at GPADAT to AH so we can do operations with it
		AND		AL, #0xF		; Preserves LED configuration that is being displayed right now also clears the other pins
								;   that the next step will use
		MOV		AH, #0xB00		; Set 2/3/4 to 1, 1 to 0 =  1011|0000|0000
		OR		AL, AH			;
		MOV		*AR1, AL		;
;Read input
		MOV		AR1, #GPADAT	; Sets AR0 to the read the input register
		MOV		AL, *AR1		; Moves contents of GPADAT to accumulator
		AND		AL, #0x4000		; Checks to see if bit 1 is zero or 1
		 B		skip15,NEQ		; If the pin is not 0 it means no key is presed so we need to skip LED setting
;Set LED part
		LC		Key9c
		B		Keypad, UNC
skip15
		MOV		AR1, #GPADAT	; Makes AR1 the location of GPADAT
		MOV		AL, *AR1		; MOves the data at GPADAT to AH so we can do operations with it
		AND		AL, #0xF		; Preserves LED configuration that is being displayed right now also clears the other pins
								;   that the next step will use
		MOV		AH, #0xB00		; Set 2/3/4 to 1, 1 to 0 =  1011|0000|0000
		OR		AL, AH			;
		MOV		*AR1, AL		;
;Read input
		MOV		AR1, #GPADAT	; Sets AR0 to the read the input register
		MOV		AL, *AR1		; Moves contents of GPADAT to accumulator
		AND		AL, #0x8000		; Checks to see if bit 1 is zero or 1
		 B		skip2,NEQ		; If the pin is not 0 it means no key is presed so we need to skip LED setting
;Set LED part
		LC		Key15c
		B		Keypad, UNC


		
;*******************************************************************************************************


; NEXT COLUMN --- 2-0



;********************************************************************************************************
		
		
		
		
		
skip2
		MOV		AR1, #GPADAT	; Makes AR1 the location of GPADAT
		MOV		AL, *AR1		; MOves the data at GPADAT to AH so we can do operations with it
		AND		AL, #0xF		; Preserves LED configuration that is being displayed right now also clears the other pins
								;   that the next step will use
		MOV		AH, #0xD00		; Set 2/3/4 to 1, 1 to 0 =  1101|0000|0000
		OR		AL, AH			;
		MOV		*AR1, AL		;
		LC		DELAY2
;Read input
		MOV		AR1, #GPADAT	; Sets AR0 to the read the input register
		MOV		AL, *AR1		; Moves contents of GPADAT to accumulator
		AND		AL, #0x1000		; Checks to see if bit 1 is zero or 1
		 B		skip5,NEQ		; If the pin is not 0 it means no key is presed so we need to skip LED setting
;Set LED part
		LC		Key2c
		B		Keypad, UNC
; So the progress here is, the first key is done, now the code just has to be copy pasted and changed a little bit so
; it can be resued for all the possible pins
skip5	
		MOV		AR1, #GPADAT	; Makes AR1 the location of GPADAT
		MOV		AL, *AR1		; MOves the data at GPADAT to AH so we can do operations with it
		AND		AL, #0xF		; Preserves LED configuration that is being displayed right now also clears the other pins
								;   that the next step will use
		MOV		AH, #0xD00		; Set 2/3/4 to 1, 1 to 0 =  1011|0000|0000
		OR		AL, AH			;
		MOV		*AR1, AL		;
;Read input
		MOV		AR1, #GPADAT	; Sets AR0 to the read the input register
		MOV		AL, *AR1		; Moves contents of GPADAT to accumulator
		AND		AL, #0x2000		; Checks to see if bit 1 is zero or 1
		 B		skip8,NEQ		; If the pin is not 0 it means no key is presed so we need to skip LED setting
;Set LED part
		LC		Key5c
		B		Keypad, UNC
		
skip8
		MOV		AR1, #GPADAT	; Makes AR1 the location of GPADAT
		MOV		AL, *AR1		; MOves the data at GPADAT to AH so we can do operations with it
		AND		AL, #0xF		; Preserves LED configuration that is being displayed right now also clears the other pins
								;   that the next step will use
		MOV		AH, #0xD00		; Set 2/3/4 to 1, 1 to 0 =  1101|0000|0000
		OR		AL, AH			;
		MOV		*AR1, AL		;
;Read input
		MOV		AR1, #GPADAT	; Sets AR0 to the read the input register
		MOV		AL, *AR1		; Moves contents of GPADAT to accumulator
		AND		AL, #0x4000		; Checks to see if bit 1 is zero or 1
		 B		skip0,NEQ		; If the pin is not 0 it means no key is presed so we need to skip LED setting
;Set LED part
		LC		Key8c			; Just calls the clear lcd subroutine
		B		Keypad, UNC
skip0
		MOV		AR1, #GPADAT	; Makes AR1 the location of GPADAT
		MOV		AL, *AR1		; MOves the data at GPADAT to AH so we can do operations with it
		AND		AL, #0xF		; Preserves LED configuration that is being displayed right now also clears the other pins
								;   that the next step will use
		MOV		AH, #0xD00		; Set 2/3/4 to 1, 1 to 0 =  1101|0000|0000
		OR		AL, AH			;
		MOV		*AR1, AL		;
;Read input
		MOV		AR1, #GPADAT	; Sets AR0 to the read the input register
		MOV		AL, *AR1		; Moves contents of GPADAT to accumulator
		AND		AL, #0x8000		; Checks to see if bit 1 is zero or 1
		 B		skip1,NEQ		; If the pin is not 0 it means no key is presed so we need to skip LED setting
;Set LED part
		LC		Key0c
		B		Keypad, UNC

;*******************************************************************************************************


; NEXT COLUMN --- 1-*



;********************************************************************************************************
		
		
		
		
		
skip1	MOV		AR1, #GPADAT	; Makes AR1 the location of GPADAT
		MOV		AL, *AR1		; MOves the data at GPADAT to AH so we can do operations with it
		AND		AL, #0xF		; Preserves LED configuration that is being displayed right now also clears the other pins
								;   that the next step will use
		MOV		AH, #0xE00		; 
		OR		AL, AH			;
		MOV		*AR1, AL		;
		LC		DELAY2
;Read input
		MOV		AR1, #GPADAT	; Sets AR0 to the read the input register
		MOV		AL, *AR1		; Moves contents of GPADAT to accumulator
		AND		AL, #0x1000		; Checks to see if bit 1 is zero or 1
		 B		skip4,NEQ		; If the pin is not 0 it means no key is presed so we need to skip LED setting
;Set LED part
		LC		Key1c			; Just calls the name subroutine
		B		Keypad, UNC
skip4	
		MOV		AR1, #GPADAT	; Makes AR1 the location of GPADAT
		MOV		AL, *AR1		; MOves the data at GPADAT to AH so we can do operations with it
		AND		AL, #0xF		; Preserves LED configuration that is being displayed right now also clears the other pins
								;   that the next step will use
		MOV		AH, #0xE00		; 
		OR		AL, AH			;
		MOV		*AR1, AL		;
;Read input
		MOV		AR1, #GPADAT	; Sets AR0 to the read the input register
		MOV		AL, *AR1		; Moves contents of GPADAT to accumulator
		AND		AL, #0x2000		; Checks to see if bit 1 is zero or 1
		 B		skip7,NEQ		; If the pin is not 0 it means no key is presed so we need to skip LED setting
;Set LED part
		LC		Key4c
		B		Keypad, UNC
skip7
		MOV		AR1, #GPADAT	; Makes AR1 the location of GPADAT
		MOV		AL, *AR1		; MOves the data at GPADAT to AH so we can do operations with it
		AND		AL, #0xF		; Preserves LED configuration that is being displayed right now also clears the other pins
								;   that the next step will use
		MOV		AH, #0xE00		; 
		OR		AL, AH			;
		MOV		*AR1, AL		;
;Read input
		MOV		AR1, #GPADAT	; Sets AR0 to the read the input register
		MOV		AL, *AR1		; Moves contents of GPADAT to accumulator
		AND		AL, #0x4000		; Checks to see if bit 1 is zero or 1
		 B		skip16,NEQ		; If the pin is not 0 it means no key is presed so we need to skip LED setting
;Set LED part
		LC		Key7c
		B		Keypad, UNC
skip16
		MOV		AR1, #GPADAT	; Makes AR1 the location of GPADAT
		MOV		AL, *AR1		; MOves the data at GPADAT to AH so we can do operations with it
		AND		AL, #0xF		; Preserves LED configuration that is being displayed right now also clears the other pins
								;   that the next step will use
		MOV		AH, #0xE00		; 
		OR		AL, AH			;
		MOV		*AR1, AL		;
;Read input
		MOV		AR1, #GPADAT	; Sets AR0 to the read the input register
		MOV		AL, *AR1		; Moves contents of GPADAT to accumulator
		AND		AL, #0x8000		; Checks to see if bit 1 is zero or 1
		 B		Keypad,NEQ		; If the pin is not 0 it means no key is presed so we need to skip LED setting
;Set LED part
		LC		Key14c
		B		Keypad, UNC
	
DELAY	nop
		nop
		nop		
		MOV		AL, #0
loop10	MOV		AR3, #5
		MOV		AH,	#0	
		INC		AL
		SUB		@AR3,AL
		B		loop110, NEQ
		B		Keypad, UNC
loop110	MOV		AR4, #40000
		INC		AH
		SUB		@AR4,AH
		B		loop110, NEQ
		B		loop10,UNC

DELAY2	nop
		nop
		nop	
		nop
		LRET
		
;***********************************************
; 				LCD STUFF					   *
;***********************************************

LCDINIT:
		; Initializations
		
	MOV		AR1, #GPAMUX2		; Sets to inputs/outputs
	MOV		AL, #0x000
	MOV		*AR1, AL
	
	MOV		AR1, #GPADIR+1		; Sets the pins to outputs
	MOV		AH, #111111b	
	MOV		*AR1, AH	
	
	MOV		AR1, #GPADAT+1 		; Do not use AR1 again while LCD writing
	
	MOV 	AH, #010011b
	MOV		*AR1, AH	
	LC		LCDDELAY
	MOV 	AH, #000011b
	MOV		*AR1, AH
	LC		LCDDELAY

	MOV 	AH, #010011b
	MOV		*AR1, AH
	LC		LCDDELAY
	MOV 	AH, #000011b
	MOV		*AR1, AH
	LC		LCDDELAY

	MOV 	AH, #010011b
	MOV		*AR1, AH
	LC		LCDDELAY	
	MOV 	AH, #000011b
	MOV		*AR1, AH
	LC		LCDDELAY

	MOV 	AH, #010010b
	MOV		*AR1, AH
	LC		LCDDELAY	
	MOV 	AH, #000010b
	MOV		*AR1, AH
	LC		LCDDELAY

	MOV 	AH, #010010b 
	MOV		*AR1, AH
	LC		LCDDELAY
	MOV 	AH, #000010b  	; 2 lines
	MOV		*AR1, AH
	LC		LCDDELAY
	MOV		AH, #011000b
	MOV		*AR1, AH
	LC		LCDDELAY
	MOV		AH, #001000b
	MOV		*AR1, AH
	LC		LCDDELAY
	
	MOV 	AH, #010000b 	; Display on; Cursor on, blink on
	MOV		*AR1, AH
	LC		LCDDELAY
	MOV 	AH, #000000b 	; Display on; Cursor on, blink on
	MOV		*AR1, AH
	LC		LCDDELAY
	MOV		AH, #011111b
	MOV		*AR1, AH
	LC		LCDDELAY
	MOV		AH, #001111b
	MOV		*AR1, AH
	LC		LCDDELAY
	
	MOV 	AH, #010000b
	MOV		*AR1, AH
	LC		LCDDELAY
	MOV 	AH, #000000b 	;Clear SCreen, Cursor home
	MOV		*AR1, AH
	LC		LCDDELAY
	MOV		AH, #010001b
	MOV		*AR1, AH
	LC		LCDDELAY
	MOV		AH, #000001b
	MOV		*AR1, AH
	LC		LCDDELAY
	
	LRET
	
	;<INITIALIZATION COMPLETE>;
	
LCD_STRING:
		
		MOV		AH, #0 ; this is where it breaks on me
loopL	MOV		AL, *AR0		; Mov Char to AL
		B		LCD_CHAR, NEQ	; If not null write the char
		LRET					; All done if there was a null char
		
LCD_CHAR:
		MOV		AL, *AR0	; points to the GPADAT
		LSR		AL, 4		; only gets the last 4 chars
		AND		AL, #1111b	; deletes everything else
		ADD		AL, #100000b ; Makes the enable low register data
		MOV		*AR1, AL	; Moves other nibble to LCD to write it
		ADD		AL, #10000b ;makes enable high register data
		MOV		*AR1, AL
		LC		LCDDELAY	
		
		
		MOV		AL, *AR0	; points to the CHAR
		AND		AL, #1111b	; only gets the first 4 chars
		ADD		AL, #100000b	; Makes the enable low and reg select high
		MOV		*AR1, AL	; Writes to GPADAT the first nibble
		ADD		AL, #010000b ; Clocks the enable
		MOV		*AR1, AL
		LC		LCDDELAY
		

		
		INC		AR0			;  updates to enxt char		
		B		loopL, UNC	; Goes back to string function		
		
LCDDELAY:
		MOV 	AL, #5000	; Small little for loop delay
loopd	DEC 	AL
		B	loopd, NEQ
		LRET
		
;***********************************************
; 			END LCD STUFF					   *
;***********************************************


;***********************************************
; 	SUBROUTINES FOR EACH KEY PRESSED		   *
;***********************************************
Key0c:

	LC LCDINIT
	MOV AR0, #Key0	; AR0 is what passes the beginning of the string
	LC LCD_STRING
	LC INIT_TIMER2_INT
	MOV AR2, #564
	LC INIT_EPWM_REST	; Initializes the sound timer
	LRET
	
Key1c:

	LC LCDINIT
	MOV AR0, #Key1	; AR0 is what passes the beginning of the string
	LC LCD_STRING
	LC INIT_TIMER2_INT
	MOV AR2, #949
	LC INIT_EPWM_REST	; Initializes the sound timer
	LRET		
	
Key2c:
	LC LCDINIT
	MOV AR0, #Key2	
	LC LCD_STRING
	LC INIT_TIMER2_INT
	MOV AR2, #896
	LC INIT_EPWM_REST	; Initializes the sound timer
	LRET

Key3c:

	LC LCDINIT
	MOV AR0, #Key3	; AR0 is what passes the beginning of the string
	LC LCD_STRING
	LC INIT_TIMER2_INT
	MOV AR2, #846
	LC INIT_EPWM_REST	; Initializes the sound timer
	LRET

Key4c:

	LC LCDINIT
	MOV AR0, #Key4	; AR0 is what passes the beginning of the string
	LC LCD_STRING
	LC INIT_TIMER2_INT
	MOV AR2, #798
	LC INIT_EPWM_REST	; Initializes the sound timer
	LRET

Key5c:

	LC LCDINIT
	MOV AR0, #Key5	; AR0 is what passes the beginning of the string
	LC LCD_STRING
	LC INIT_TIMER2_INT
	MOV AR2, #753
	LC INIT_EPWM_REST	; Initializes the sound timer
	LRET

Key6c:

	LC LCDINIT
	MOV AR0, #Key6	; AR0 is what passes the beginning of the string
	LC LCD_STRING
	LC INIT_TIMER2_INT
	MOV AR2, #711
	LC INIT_EPWM_REST	; Initializes the sound timer
	LRET

Key7c:

	LC LCDINIT
	MOV AR0, #Key7	; AR0 is what passes the beginning of the string
	LC LCD_STRING
	LC INIT_TIMER2_INT
	MOV AR2, #671
	LC INIT_EPWM_REST	; Initializes the sound timer
	LRET

Key8c:

	LC LCDINIT
	MOV AR0, #Key8	; AR0 is what passes the beginning of the string
	LC LCD_STRING
	LC INIT_TIMER2_INT
	MOV AR2, #633
	LC INIT_EPWM_REST	; Initializes the sound timer
	LRET

Key9c:

	LC LCDINIT
	MOV AR0, #Key9	; AR0 is what passes the beginning of the string
	LC LCD_STRING
	LC INIT_TIMER2_INT
	MOV AR2, #599
	LC INIT_EPWM_REST	; Initializes the sound timer
	LRET
	
Key14c:
	LC DECENDING
	LRET
	
Key15c:

	LC LCDINIT
	MOV AR0, #Key15	; AR0 is what passes the beginning of the string
	LC LCD_STRING
	LC ACENDING
	LRET
	
KeyAc:

	LC LCDINIT
	MOV AR0, #KeyA	; AR0 is what passes the beginning of the string
	LC LCD_STRING
	LC INIT_TIMER2_INT
	MOV AR2, #533
	LC INIT_EPWM_REST	; Initializes the sound timer
	LRET	
	
KeyBc:

	LC LCDINIT
	MOV AR0, #KeyB	; AR0 is what passes the beginning of the string
	LC LCD_STRING
	LC INIT_TIMER2_INT
	MOV AR2, #503
	LC INIT_EPWM_REST	; Initializes the sound timer
	LRET
	
KeyCc:

	LC LCDINIT
	MOV AR0, #KeyC	; AR0 is what passes the beginning of the string
	LC LCD_STRING
	LC INIT_TIMER2_INT
	MOV AR2, #475
	LC INIT_EPWM_REST	; Initializes the sound timer
	LRET	
	
KeyDc:

	LC LCDINIT
	MOV AR0, #KeyD	; AR0 is what passes the beginning of the string
	LC LCD_STRING
	LC INIT_TIMER2_INT
	MOV AR2, #448
	LC INIT_EPWM_REST	; Initializes the sound timer
	LRET
	
;***********************************************
; 	END SUBROUTINES FOR EACH KEY PRESSED	   *
;***********************************************

;***********************************************
; 			INITIALIZE CPU/timers			   *
;***********************************************
CPU_INIT:
		EALLOW 						; Allow access to protected registers
		SETC 	OBJMODE 			; Allow 32 bit mov instructions
								; WDCR is watchdog timer control register
								; In constants section need to set WDCR=0x7029
		MOV 	AL,#1101000b 	; Disable the watchdog timer.
								; Must have 101 in bits 5, 4, 3 for
								; any writes to WDCR. 1 in bit 6
								; disables watchdog
		MOV 	AR1,#WDCR
		MOV		*AR1, AL 		; Disables watchdog timer
		LRET
		
INIT_EPWM_REST:
	INC AR5
	MOV AR0, #PCLKCR1	; enables the epwm1 timers
	OR *AR0, #0x1

	MOV	AR0, #TBCTL	; sets all the needed ctrl registers for the epwm
	MOV	AR1, #0xC0B8	
	MOV	*AR0, AR1
	
	MOV AR0, #TBPRD		; sets the toggler frequency so you can play music
	MOV	AR1, AR2
	MOV	*AR0, AR1

	MOV AR0, #AQCTLA	; makes it so it toggles and when the counter gets to the period
	MOV	AR1, #0xC
	MOV	*AR0, AR1
	
	MOV AR0, #PCLKCR0	; Enables the TimerCLK for the epwm (also needs PCLKCCR1)
	OR *AR0, #0x4
	
;	MOV AR0, #CMPCTL	; Could never get the interupts working, but decided
;	MOV	AR1, #0x50		; it was not that important anyway so these are not needed
;	MOV	*AR0, AR1
	
;	MOV	AR0, #CMPB		; also for doing interupts
;	MOV	AR1, #0xF0F0
;	MOV	*AR0, AR1
	
	LRET
	
INIT_TIMER2_INT:

	CLRC VMAP					; allows writing ISRdirectly to vector
	
	MOV	AR0, #TIMER1PRD+8		; sets period				
	MOV	*AR0, #PERIODL	
	MOV	AR0, #TIMER1PRDH+8						
	MOV	*AR0, #PERIODH							
	MOV	AR0, #TIMER1PR+8		; sets prescaler			
	MOV	*AR0, #0x0FFF	
	MOV	AR0, #TIMER1PRH+8						
	MOV	*AR0, #0					
	MOV	AR0, #TIMER1TCR+8		; enables timer			
	TSET	*AR0, #14				
	MOV	AR0, #TIMER1TCR+8		; loads prescaler and period			
	TSET	*AR0, #5				
								
	MOVL XAR0, #INT13_VECT+2	;need to load interrupt vector with isr address
	MOV *XAR0++, #TIMER2_ISR	;load lower byte (little endian)
	MOV *XAR0, #TIMER2_ISR>>16	;load upper byte							

	LRET
	
TIMER2_ISR:

	MOV AR0, #PCLKCR1	; enables the epwm1 timers
	OR *AR0, #0x1

	MOV	AR0, #TBCTL	; sets all the needed ctrl registers for the epwm
	MOV	AR1, #0xC0B8	
	MOV	*AR0, AR1
	
	MOV AR0, #TBPRD		; sets the toggler frequency so you can play music
	MOV	AR1, #0
	MOV	*AR0, AR1

	MOV AR0, #AQCTLA	; makes it so it toggles and when the counter gets to the period
	MOV	AR1, #0xC
	MOV	*AR0, AR1
	
	MOV AR0, #PCLKCR0	; Enables the TimerCLK for the epwm (also needs PCLKCCR1)
	OR *AR0, #0x4
	
	MOV AR1, #GPATOGGLE			;load AR1 with address of GPIO0
	MOV *AR1, #8				;toggle  GPIO0
	
	INC AR4
	DEC AR3
	
	IRET
	
INIT_OUTPUTS:
	PUSH AR0
	PUSH AR1
	MOV AR1,#GPAMUX1
	OR *AR1,#1
	MOV AR0,#1111b		;set GPIO0 as an output
	MOV AR1,#GPADIR
	MOV *AR1,AR0
	POP AR1
	POP AR0
	LRET
ACENDING:
	MOV AR4, #0
checkerA	MOV AR0, #Start
	MOV	AL, AR4
	ADD	AR0, AL
	MOV AL, *AR0
	MOV	AR2, AL
	B	ENDA, EQ
	LC INIT_EPWM_REST	; Initializes the sound timer
	B	checkerA, UNC
	
ENDA	LRET
DECENDING:
	LC LCDINIT
	MOV AR0, #Key14	; AR0 is what passes the beginning of the string
	LC LCD_STRING
	MOV AR3, #Start+13
checkerD
	MOV	AL, *AR3
	B	ENDD, EQ
	MOV	AR2, AL
	LC INIT_EPWM_REST	; Initializes the sound timer
	B	checkerD, UNC
	
ENDD	LRET
;***********************************************
; 		END INITIALIZE CPU/timers			   *
;***********************************************